VERSION 5.00
Begin VB.Form frmRemoteCPU 
   Caption         =   "Serial Port Complete"
   ClientHeight    =   1344
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3024
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1344
   ScaleWidth      =   3024
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   492
      Left            =   2160
      TabIndex        =   4
      Top             =   720
      Width           =   732
   End
   Begin VB.Frame fraRemoteCPU 
      Caption         =   "Remote CPU"
      Height          =   1092
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1812
      Begin VB.OptionButton optRemoteCPU 
         Caption         =   "8052-Basic"
         Height          =   252
         Index           =   2
         Left            =   120
         TabIndex        =   3
         Top             =   720
         Width           =   1452
      End
      Begin VB.OptionButton optRemoteCPU 
         Caption         =   "Basic Stamp"
         Height          =   252
         Index           =   1
         Left            =   120
         TabIndex        =   2
         Top             =   480
         Width           =   1452
      End
      Begin VB.OptionButton optRemoteCPU 
         Caption         =   "PC"
         Height          =   252
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   1452
      End
   End
End
Attribute VB_Name = "frmRemoteCPU"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Enables the user to specify the type of remote computer.
'Each has different communication requirements.

Private Sub cmdOK_Click()
Dim Index As Integer
Index = -1
Do
    Index = Index + 1
Loop Until optRemoteCPU(Index).Value = True
Select Case Index
    Case 0
        frmMain.RemoteCPU = "PC"
    Case 1
        frmMain.RemoteCPU = "Basic Stamp"
    Case 2
        frmMain.RemoteCPU = "8052-Basic"
End Select
Hide
End Sub

Private Sub Form_Load()
optRemoteCPU(0).Value = True
Call GetSettings
End Sub

Private Sub Form_Unload(Cancel As Integer)
Call SaveSettings
End Sub

Private Sub GetSettings()
Dim Index As Integer
Index = -1
frmMain.RemoteCPU = GetSetting(ProjectName, "Startup", "RemoteCPU", "PC")
Do
    Index = Index + 1
Loop Until optRemoteCPU(Index).Caption = frmMain.RemoteCPU Or Index = 2
optRemoteCPU(Index).Value = True
End Sub

Private Sub SaveSettings()
SaveSetting ProjectName, "Startup", "RemoteCPU", frmMain.RemoteCPU
End Sub

