VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.1#0"; "RICHTX32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Serial Port Complete"
   ClientHeight    =   4296
   ClientLeft      =   132
   ClientTop       =   420
   ClientWidth     =   7032
   LinkTopic       =   "Form1"
   ScaleHeight     =   4296
   ScaleWidth      =   7032
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmrTransferInterval 
      Enabled         =   0   'False
      Left            =   1560
      Top             =   4560
   End
   Begin VB.Frame fraTransfer 
      Caption         =   "Transfer"
      Height          =   1812
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   6732
      Begin VB.Frame fraStart 
         Height          =   1452
         Left            =   4560
         TabIndex        =   11
         Top             =   240
         Width           =   1932
         Begin VB.CommandButton cmdStart 
            Caption         =   "Start"
            Height          =   492
            Left            =   120
            TabIndex        =   13
            Top             =   240
            Width           =   1692
         End
         Begin VB.CommandButton cmdStop 
            Caption         =   "Stop"
            Height          =   492
            Left            =   120
            TabIndex        =   12
            Top             =   840
            Width           =   1692
         End
      End
      Begin VB.Frame fraInterval 
         Caption         =   "Interval"
         Height          =   1332
         Left            =   120
         TabIndex        =   3
         Top             =   360
         Width           =   4332
         Begin VB.Frame fraSingleOrContinuous 
            Height          =   732
            Left            =   2640
            TabIndex        =   8
            Top             =   360
            Width           =   1572
            Begin VB.OptionButton optSingleOrContinuous 
               Caption         =   "Continuous"
               Height          =   252
               Index           =   1
               Left            =   240
               TabIndex        =   10
               Top             =   360
               Width           =   1212
            End
            Begin VB.OptionButton optSingleOrContinuous 
               Caption         =   "Single"
               Height          =   252
               Index           =   0
               Left            =   240
               TabIndex        =   9
               Top             =   120
               Width           =   1212
            End
         End
         Begin VB.OptionButton optIntervalUnits 
            Caption         =   "Hours"
            Height          =   252
            Index           =   2
            Left            =   1560
            TabIndex        =   7
            Top             =   840
            Width           =   972
         End
         Begin VB.OptionButton optIntervalUnits 
            Caption         =   "Minutes"
            Height          =   252
            Index           =   1
            Left            =   1560
            TabIndex        =   6
            Top             =   600
            Width           =   972
         End
         Begin VB.OptionButton optIntervalUnits 
            Caption         =   "Seconds"
            Height          =   252
            Index           =   0
            Left            =   1560
            TabIndex        =   5
            Top             =   360
            Width           =   972
         End
         Begin VB.ComboBox cboIntervalValue 
            Height          =   288
            Left            =   240
            Style           =   2  'Dropdown List
            TabIndex        =   4
            Top             =   600
            Width           =   1212
         End
      End
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "Test"
      Height          =   372
      Left            =   5760
      TabIndex        =   1
      Top             =   4440
      Width           =   972
   End
   Begin RichTextLib.RichTextBox rtxStatus 
      Height          =   2172
      Left            =   120
      TabIndex        =   0
      Top             =   2040
      Width           =   6732
      _ExtentX        =   11875
      _ExtentY        =   3831
      _Version        =   327680
      TextRTF         =   $"frmMain.frx":0000
   End
   Begin VB.Timer tmrTimeout 
      Enabled         =   0   'False
      Left            =   960
      Top             =   4560
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   240
      Top             =   4440
      _ExtentX        =   804
      _ExtentY        =   804
      _Version        =   327680
      DTREnable       =   -1  'True
   End
   Begin VB.Menu mnuSetup 
      Caption         =   "Setup"
      Index           =   0
      Begin VB.Menu mnuPortSettings 
         Caption         =   "Port Settings"
         Index           =   0
         Shortcut        =   ^P
      End
      Begin VB.Menu mnuNodes 
         Caption         =   "Nodes"
         Index           =   1
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuDataFile 
         Caption         =   "Data File"
         Index           =   2
         Shortcut        =   ^D
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'A master node communicates with up to 7 slave nodes
'over a half-duplex RS-485 interface.
'Each node has an address.
'Each message consists of the receiver's address, followed by
'4 ASCII hex bytes representing 2 binary values.
'Each reply consists of the sender's address,
'followed by 4 ASCII hex bytes representing 2 binary values.
Option Base 0
'Delay (milliseconds) to ensure RTS has toggled (Windows delay):
Const RTSDelay = 200
'Delay (milliseconds) before enabling transmitter,
'to allow the slave to disable its transmitter.
Const EnableDelay = 500
'Delay (milliseconds) to wait for a reply from a slave.
Const ReplyDelay = 3000
'Node 0 is the master; other nodes are slaves.
Const HighestNodeNumber = 7
'With each message, the master sends and receives 4 ASCII hex bytes.
Const NumberOfDataBytesOut = 4
Const NumberOfDataBytesIn = 4

Private Type typNodes
    Address(0 To HighestNodeNumber) As Byte
    DataOut1(0 To HighestNodeNumber) As Byte
    DataOut2(0 To HighestNodeNumber) As Byte
    DataIn1(0 To HighestNodeNumber) As Byte
    DataIn2(0 To HighestNodeNumber) As Byte
    Status(0 To HighestNodeNumber) As String
    Cpu(0 To HighestNodeNumber) As String
    Active(0 To HighestNodeNumber) As Integer
    LastAccess(0 To HighestNodeNumber) As String
End Type
Private Type typDataTransferFormat
    SingleOrContinuous As String
    IntervalUnits As String
    IntervalValue As Single
End Type

Dim Nodes As typNodes
Dim SelectedNode As Integer
Dim PollInterval As Integer
Dim DataOut(NumberOfDataBytesOut - 1) As Byte
Dim DataIn(NumberOfDataBytesIn - 1) As Byte
Dim DataTransferFormat As typDataTransferFormat
Dim PreviousTime As Date
Dim TimeOfTransfer As String
Dim TransferInProgress As Boolean

Private Function fncConfirmTransmittedData _
    (Buffer As Variant) _
    As Integer
'Ensure that all data has transmitted by reading it back.
'Receiver must be enabled!
'Returned values:
'-1 = Data read back successfully
'0 = Data didn't match
'1 = Timeout
Dim DataReadBack As String
'Estimate the time to transmit the data:
tmrTimeout.Interval = OneByteDelay * LenB(Buffer) + 500
tmrTimeout.Enabled = True
TimedOut = False
Do
    DoEvents
Loop Until MSComm1.InBufferCount >= Len(Buffer) Or TimedOut = True
DataReadBack = MSComm1.Input
If StrComp(DataReadBack, Buffer, vbBinaryCompare) = 0 Then
    fncConfirmTransmittedData = -1
Else
    If TimedOut = False Then
        fncConfirmTransmittedData = 0
    Else
        fncConfirmTransmittedData = 1
    End If
End If
tmrTimeout.Enabled = False
TimedOut = False
End Function

Private Function fncCreateMessage(NodeNumber As Integer) As String
'A message consists of four bytes in ASCII hex format.
'Each ASCII hex pair represents the value of a byte.
Dim MessageLength As Integer
Dim MessageToSend As String
    MessageLength = NumberOfDataBytesOut - 1
    Call GetDataToSend(NodeNumber)
    'Create the message, consisting of
    '4 bytes that contain the 2 data bytes in ASCII hex format.
    'Each byte represents 1 hex digit (4 bits).
    'Convert the 2 data bytes to ASCII hex
    'and store in the Message string.
    MessageToSend = fncByteToAsciiHex(Nodes.DataOut1(NodeNumber)) & _
        fncByteToAsciiHex(Nodes.DataOut2(NodeNumber))
    fncCreateMessage = MessageToSend
End Function
Private Function fncDisplayDateAndTime() As String
'Date and time formatting.
fncDisplayDateAndTime = _
    CStr(Format(Date, "General Date")) & ", " & _
        (Format(Time, "Long Time"))
End Function

Private Function fncWaitForAck(NodeNumber As Integer) As Boolean
'End on receiving Acknowledge from the slave or timeout.
Dim Ack As Boolean
Dim NodeAddress As String
Dim ReceivedData As String
'The Acknowledge is the node address.
NodeAddress = Chr(Nodes.Address(NodeNumber))
Ack = False
tmrTimeout.Interval = ReplyDelay
'Disable the transmitter until Ack is received or timeout.
Call DisableTransmitter
'Wait for Acknowledge.
Do
    tmrTimeout.Enabled = True
    TimedOut = False
    Do
        DoEvents
    Loop Until (MSComm1.InBufferCount >= 1) Or (TimedOut = True)
    If TimedOut = False Then
        tmrTimeout.Enabled = False
        'Read the byte & compare to what was sent.
        ReceivedData = MSComm1.Input
        If StrComp _
            (ReceivedData, NodeAddress, vbBinaryCompare) = 0 Then
                Ack = True
            Nodes.DataIn1(NodeNumber) = Asc(ReceivedData)
        Else
            'if the Ack doesn't match the node address:
            Ack = False
            Call SaveResults(NodeNumber, 0, 0, "Ack Error")
         End If
    Else
        Ack = False
        Call SaveResults(NodeNumber, 0, 0, "No Ack")
    End If
Loop Until Ack = True Or TimedOut = True
tmrTimeout.Enabled = False
fncWaitForAck = Ack
TimedOut = False
Call EnableTransmitter(EnableDelay)
End Function

Private Function fncWaitForReply(NodeNumber As Integer) As Boolean
'From the slave, read the node address & 4 ASCII hex bytes.
Dim Ack As Boolean
Dim Reply As Boolean
Dim ReceivedData As String
Ack = False
Reply = False
TimedOut = False
tmrTimeout.Interval = ReplyDelay
'Disable the transmitter until bytes are received or timeout.
Call DisableTransmitter
tmrTimeout.Enabled = True
Do
    'Wait for reply
    TimedOut = False
    Do
        DoEvents
    Loop Until (MSComm1.InBufferCount > 4) Or (TimedOut = True)
    If TimedOut = False Then
        tmrTimeout.Enabled = False
        ReceivedData = MSComm1.Input
        Reply = True
        If StrComp(Asc(Left(ReceivedData, 1)), _
            Nodes.Address(NodeNumber), vbBinaryCompare) = 0 Then
            'If the first byte equals the slave's address,
            'get the numeric value of each pair of ASCII hex bytes.
            Call SaveResults _
                (NodeNumber, _
                Val("&h" & Mid(ReceivedData, 2, 2)), _
                 Val("&h" & Mid(ReceivedData, 4, 2)), _
                 "OK")
        Else
            'If the first byte doesn't equal the node address:
             Call SaveResults(NodeNumber, 0, 0, "Data Error")
        End If
     Else
        'If the wait for a reply times out:
        Call SaveResults(NodeNumber, 0, 0, "Reply Timeout")
     End If
Loop Until Reply = True Or TimedOut = True
tmrTimeout.Enabled = False
Call EnableTransmitter(EnableDelay)
fncWaitForReply = Reply
End Function

Private Sub cboIntervalValue_Click()
'Store the selected interval for data transfers.
DataTransferFormat.IntervalValue = Val(cboIntervalValue.Text)
'With shorter intervals, check elapsed time more often.
Select Case DataTransferFormat.IntervalUnits
    Case "seconds"
        tmrTransferInterval.Interval = 100
    Case "minutes", "hours"
        tmrTransferInterval.Interval = 1000
End Select
End Sub

Private Sub cmdStart_Click()
'Initiate data transfer.
Select Case DataTransferFormat.SingleOrContinuous
    Case "single"
        'Transfer data once.
        'Disable the Start button until polling is finished.
        cmdStart.Enabled = False
        Call PollSlave
        cmdStart.Enabled = True
    Case "continuous"
        'Do one transfer immediately, then let the timer take over.
        cmdStart.Enabled = False
        cmdStop.Enabled = True
        cmdStop.SetFocus
        PreviousTime = Now
        tmrTransferInterval.Enabled = True
        Call PollSlave
    Case Else
End Select
End Sub

Private Sub cmdStop_Click()
'Stop transferring data.
tmrTransferInterval.Enabled = False
cmdStop.Enabled = False
cmdStart.Enabled = True
Call DisableTransmitter
End Sub

Sub DisableTransmitter()
'Set RTS true (high) to disable the RS485 transmitter
'by bringing its chip-enable low.
'Assumes that a second RS-232 receiver inverts RTS.
MSComm1.RTSEnable = True
End Sub

Sub EnableTransmitter(EnableDelay As Single)
'Set RTS false (low) to enable the RS485 transmitter.
'Assumes that a second RS-232 receiver has inverted RTS.
'Delay in milliseconds allows remote node to disable its transmitter.
Call Delay(EnableDelay)
MSComm1.RTSEnable = False
'Windows delay:
Call Delay(RTSDelay)
End Sub

Private Sub Form_Load()
Show
Call GetSettings
Call Startup
Load frmPortSettings
Load frmNodes
TransferInProgress = False
tmrTimeout.Interval = ReplyDelay
tmrTransferInterval.Enabled = False
tmrTimeout.Enabled = False
TimedOut = False
Call InitializeDisplayElements
SaveDataInFile = False
Call InitializeNodes
Call GetNewNodeSettings
'The master's transmitter is enabled,
'except when receiving replies.
Call EnableTransmitter(0)
End Sub

Private Sub Form_Unload(Cancel As Integer)
Call ShutDown
Unload frmNodes
Unload frmDataFile
Unload frmPortSettings
Close #2
End
End Sub

Private Sub GetDataToSend(NodeNumber As Integer)
'Dummy data for testing: the current hour and minute.
Dim CurrentTime As String
CurrentTime = CStr(Format(Time, "nnss"))
Nodes.DataOut1(NodeNumber) = Val(Left(CurrentTime, 2))
Nodes.DataOut2(NodeNumber) = Val(Right(CurrentTime, 2))
End Sub

Public Sub GetNewNodeSettings()
'Store user changes made on the Nodes form.
Dim Count As Integer
    Nodes.Address(0) = CInt("&h" & frmNodes.cboAddress(0).Text)
For Count = 1 To 7
    Nodes.Cpu(Count) = frmNodes.cboCPU(Count).Text
    Nodes.Address(Count) = CInt("&h" & frmNodes.cboAddress(Count).Text)
    Nodes.Active(Count) = frmNodes.chkNodeActive(Count).Value
Next Count
End Sub

Private Sub InitializeDisplayElements()
optSingleOrContinuous(0).Value = True
optIntervalUnits(0).Value = True
cboIntervalValue.ListIndex = 0
rtxStatus.Locked = True
rtxStatus.Text = ""
DataTransferFormat.IntervalValue = 1
cmdStop.Enabled = False
End Sub

Private Sub InitializeNodes()
Dim Count As Integer
For Count = 0 To HighestNodeNumber
    Nodes.DataIn1(Count) = 0
    Nodes.DataIn2(Count) = 0
    Nodes.Status(Count) = ""
    Nodes.LastAccess(Count) = ""
    Nodes.Cpu(Count) = ""
Next Count
Call UpdateDisplay
End Sub

Private Sub mnuDataFile_Click(Index As Integer)
frmDataFile.Show
End Sub

Private Sub mnuNodes_Click(Index As Integer)
frmNodes.Show
End Sub

Private Sub mnuPortSettings_Click(Index As Integer)
frmPortSettings.Show
End Sub

Private Sub MSComm1_OnComm()
'Handles all Comm events
Dim ErrorMessage As String
Select Case MSComm1.CommEvent
    'Handle each event or error by placing
    'code below each case statement
    
    'Errors
    Case comEventBreak
        ErrorMessage = "A Break was received."
    Case comEventCDTO
        ErrorMessage = "CD (RLSD) Timeout."
    Case comEventCTSTO
        ErrorMessage = "CTS Timeout."
    Case comEventDSRTO
        ErrorMessage = "DSR Timeout."
    Case comEventFrame
        ErrorMessage = "Framing Error"
    Case comEventOverrun
        ErrorMessage = "Overrun; data Lost."
    Case comEventRxOver
        ErrorMessage = "Receive buffer overflow."
    Case comEventRxParity
        ErrorMessage = "Parity Error."
     Case comEventTxFull
        ErrorMessage = "Transmit buffer full."
     Case comEventDCB
        ErrorMessage = "Unexpected error retrieving DCB."

    ' Events
    Case comEvCD
        ErrorMessage = "Change in the CD line."
    Case comEvCTS
        ErrorMessage = "Change in the CTS line."
    Case comEvDSR
        ErrorMessage = "Change in the DSR line."
    Case comEvRing
        ErrorMessage = "Change in the RI line."
     Case comEvReceive
        ErrorMessage = "Receive buffer has RThreshold number of characters."
     Case comEvSend
        ErrorMessage = "Transmit buffer has SThreshold number of characters."
     Case comEvEOF
        ErrorMessage = "EOF character (1Ah) received."
End Select
'Use for debuggging:
'Debug.Print ErrorMessage
End Sub

Private Sub optIntervalUnits_Click(Index As Integer)
'Set the interval combo box to match the units selected.
Dim Maximum As Integer
Dim Count As Integer
Select Case Index
    Case 0
        Maximum = 59
        DataTransferFormat.IntervalUnits = "seconds"
    Case 1
        Maximum = 59
        DataTransferFormat.IntervalUnits = "minutes"
    Case 2
        Maximum = 24
        DataTransferFormat.IntervalUnits = "hours"
End Select
cboIntervalValue.Clear
For Count = 1 To Maximum
    cboIntervalValue.AddItem CStr(Count)
Next Count
cboIntervalValue.ListIndex = 0
End Sub

Private Sub optPollUnits_Click(Index As Integer)
'Set the combo box items to match the units selected.
Dim Maximum As Integer
Dim Count%
Select Case Index
    Case 0, 1
        'seconds, minutes
        Maximum = 59
    Case 2
        'hours
        Maximum = 24
End Select
End Sub

Private Sub optSingleOrContinuous_Click(Index As Integer)
Select Case Index
    Case 0
        DataTransferFormat.SingleOrContinuous = "single"
        'Disable interval selection:
        optIntervalUnits(0).Enabled = False
        optIntervalUnits(1).Enabled = False
        optIntervalUnits(2).Enabled = False
    Case 1
        DataTransferFormat.SingleOrContinuous = "continuous"
        'Enable interval selection:
        optIntervalUnits(0).Enabled = True
        optIntervalUnits(1).Enabled = True
        optIntervalUnits(2).Enabled = True
End Select
End Sub

Private Sub PollSlave()
'Send the node address & wait for Acknowledge.
'If Ack received, send data, wait for reply.
'Store the results.
Dim AckReceived As Boolean
Dim ReplyReceived As Boolean
Dim NumberOfTries As Integer
Dim LastNode As Integer
Dim Count As Integer
Dim MessageToSend As Variant
Dim AttemptNumber As Integer
Dim TransmitFinished As Boolean
Dim Buffer As Variant
TransferInProgress = True
For Count = 1 To HighestNodeNumber
'Skip the node if it isn't selected (Active) on the Nodes form.
    If Nodes.Active(Count) = 1 Then
        'Clear the transmit and receive buffers
        MSComm1.OutBufferCount = 0
        If MSComm1.InBufferCount > 0 Then
            Buffer = MSComm1.Input
        End If
        'Create the message from the stored values.
        MessageToSend = fncCreateMessage(Count)
        'Store the time of the poll.
        Nodes.LastAccess(Count) = fncDisplayDateAndTime
        'Send the node address as a text character.
        Buffer = Chr(Nodes.Address(Count))
        'For Stamp and other slaves without input buffers,
        'poll more than once if needed.
        Select Case Nodes.Cpu(Count)
            Case "PC"
                NumberOfTries = 1
            Case "Stamp"
                NumberOfTries = 2
        End Select
        AttemptNumber = 0
        Do
            MSComm1.Output = Buffer
            'Wait for the data to transmit
            Select Case fncConfirmTransmittedData(Buffer)
                Case -1
                    'If success, wait for Acknowledge.
                    AckReceived = fncWaitForAck(Count)
                Case 0
                    Nodes.Status(Count) = "Transmit error"
                Case 1
                    Nodes.Status(Count) = "Ack Timeout"
            End Select
            AttemptNumber = AttemptNumber + 1
        Loop Until AckReceived = True Or AttemptNumber = NumberOfTries
        If AckReceived = True Then
            MSComm1.Output = MessageToSend
            'Delay to let the data transmit
            Select Case fncConfirmTransmittedData(MessageToSend)
                Case -1
                    'Data has transmitted.
                    'Wait for the slave's reply.
                    ReplyReceived = fncWaitForReply(Count)
                Case Else
                    Nodes.Status(Count) = "Transmit error"
            End Select
        End If
        Call UpdateDisplay
    End If
Next Count
If SaveDataInFile = True Then
    Call WriteResultsToFile
End If
TransferInProgress = False
End Sub

Private Sub SaveResults _
    (NodeNumber As Integer, _
    Data1 As Byte, _
    Data2 As Byte, _
    ResultStatus As String)
    Nodes.DataIn1(NodeNumber) = Data1
    Nodes.DataIn2(NodeNumber) = Data2
    Nodes.Status(NodeNumber) = ResultStatus
End Sub

Private Sub WriteResultsToFile()
'Save received data and time in a file.
Dim Count As Integer
For Count = 1 To HighestNodeNumber
    'Skip if the node isn't selected (active) on the Nodes form.
    If Nodes.Active(Count) = 1 Then
        Write #2, _
            Count, _
            Nodes.LastAccess(Count), _
            Nodes.DataOut1(Count), _
            Nodes.DataOut2(Count), _
            Nodes.DataIn1(Count), _
            Nodes.DataIn2(Count), _
            Nodes.Status(Count)
    End If
Next Count
End Sub

Private Sub tmrTransferInterval_Timer()
'See if it's time to do a transfer.
Dim CurrentTime As Date
Dim Units As String
CurrentTime = Now
Select Case DataTransferFormat.IntervalUnits
    Case "seconds"
        Units = "s"
    Case "minutes"
        Units = "n"
    Case "hours"
        Units = "h"
End Select
'If elapsed time since the last transfer is more than
'the selected interval, do a data transfer.
If DateDiff(Units, PreviousTime, CurrentTime) >= _
        DataTransferFormat.IntervalValue Then
    PreviousTime = CurrentTime
    'But don't start a new transfer if one is in progress.
    If TransferInProgress = False Then
        Call PollSlave
    End If
End If
End Sub

Private Sub tmrTimeout_Timer()
tmrTimeout.Enabled = False
TimedOut = True
End Sub

Private Sub UpdateDisplay()
'Show the latest information for all nodes
Dim Column As Integer
Dim DataIn1Display As String
Dim DataIn2Display As String
Dim Count As Integer
'Set up 5 columns
With rtxStatus
        .SelTabCount = 5
        For Column = 0 To .SelTabCount - 1
            .SelTabs(Column) = 1000 * Column
        Next Column
    End With
rtxStatus.Text = "Node #" & Chr(vbKeyTab) _
    & "Data out" & Chr(vbKeyTab) _
    & "Data in" & Chr(vbKeyTab) _
    & "Status" & Chr(vbKeyTab) _
    & "Last Access" & vbCrLf
For Count = 1 To HighestNodeNumber
    'Skip if the node isn't selected (active) on the Nodes form.
    If Nodes.Active(Count) = 1 Then
    Select Case Nodes.Status(Count)
           Case "OK"
                DataIn1Display = _
                    fncByteToAsciiHex(Nodes.DataIn1(Count))
                DataIn2Display = _
                    fncByteToAsciiHex(Nodes.DataIn2(Count))
           Case Else
                DataIn1Display = ""
                DataIn2Display = ""
        End Select
        rtxStatus.SelStart = Len(rtxStatus.Text)
        rtxStatus.SelText = _
             Hex$(Count) & Chr(vbKeyTab) _
            & fncByteToAsciiHex(Nodes.DataOut1(Count)) & "   " _
            & fncByteToAsciiHex(Nodes.DataOut2(Count)) & Chr(vbKeyTab) _
            & DataIn1Display & "  " & DataIn2Display & Chr(vbKeyTab) _
            & Nodes.Status(Count) & Chr(vbKeyTab) _
            & Nodes.LastAccess(Count) & vbCrLf
    End If
Next Count
End Sub

Public Function fncInitializeComPort _
    (BitRate As Long, PortNumber As Integer) As Boolean
'BitRate and PortNumber are passed to this routine.
'All other properties are set explicitly in the code.
Dim ComSettings As String
If MSComm1.PortOpen = True Then
    MSComm1.PortOpen = False
End If
ComSettings = CStr(BitRate) & ",N,8,1"
MSComm1.CommPort = PortNumber
' bit rate, no parity, 8 data, and 1 stop bit.
MSComm1.Settings = ComSettings
'Set to 0 to read entire buffer on Input
MSComm1.InputLen = 0
MSComm1.InBufferSize = 256
'Input and output data are text.
MSComm1.InputMode = comInputModeText
'MSComm does no handshaking.
MSComm1.Handshaking = comNone
MSComm1.OutBufferSize = 256
MSComm1.EOFEnable = False
'No OnComm event on received data.
MSComm1.RThreshold = 0
'No OnComm transmit event.
MSComm1.SThreshold = 0
MSComm1.PortOpen = True
OneByteDelay = fncOneByteDelay(BitRate)
End Function

